#include "TcpSocket.hpp"
#include "NetConst.hpp"
#include "values/DnaManager.hpp"
#include <iostream>
#include <fstream>
#include <vector>

int main()
{
  int sock = TcpSocket::connectt("localhost", 8888);

  if (sock < 0)
  {
    printf("Error %d", sock);
    return 0;
  }

  std::ifstream idf("ID.bin", std::ios_base::binary);

  uint64_t ID = 0;

  idf.read((char *)&ID, sizeof(ID));
  printf("id: %ld\n", ID);

  TcpSocket::sendt(sock, &StartHeader, sizeof(StartHeader));
  TcpSocket::sendt(sock, &ID, sizeof(ID));

  size_t needed_gen = 0;

  TcpSocket::recvt(sock, &needed_gen, sizeof(needed_gen));

  char filename[20];
  int ret = sprintf(filename, "gen%04ld.bin", needed_gen);

  idf.close();
  idf.open(filename);

  std::vector<NetUnit> net;
  net.resize(NUM_PER_GEN);

  idf.read((char *)net.data(), NUM_PER_GEN * sizeof(NetUnit));
  TcpSocket::sendt(sock, net.data(), NUM_PER_GEN * sizeof(NetUnit));

  TcpSocket::closet(sock);

  return 0;
}